{
Ralis sous Windows XP / Delphi 6 Personnel / Rseau local
Par Christian Gruais (cgruais@hotmail.com)
Pour http://liocity.free.fr/

------------------------------------------------------------------
Tutorial "COMMENT REALISER UN PROG DE JEU EN RESEAU, AVEC UN CHAT"
------------------------------------------------------------------

Ce tutorial ne prend en compte qu'un seul client, mais on peut en grer autant que l'on
souhaite. Pour cela, on utilisera :
    ServerSocket1.Socket.Connections[n].RemoteHost : Nom des clients
    ServerSocket1.Socket.ActiveConnections         : Nombre de clients
Dans ce dernier cas, il faudra que le serveur redispatche  tous les autres clients les trames
qu'il reoit d'un client.
Si vous conservez le principe d'un seul client (comme c'est le cas de ce prog), pensez  ajouter
un code pour interdire la connexion d'autres clients qui pourraient perturber le cours du jeu.

On peut utiliser autant de code de trame que l'on veut ( l'instar de CodeTrameJeu)
pour passer toutes sortes de formes d'infos (nom des joueurs au dbut, etc...)
Pour les codes de trames, j'utilise des caractres pas communs pour tre sr qu'ils ne soient
pas confondus avec des textes de chat.
Dans ce prog, toutes les codes de trames non reconnus sont renvoy dans le chat.

Lorsque le client se connecte, il doit saisir le nom du serveur dans EditNomServeur, mais il
peut aussi saisir l'adresse IP (c'est d'ailleurs srement prfrable sur Internet, je n'ai
test ce prog qu'en rseau local).

Si vous voulez viter les messages d'erreur disgrcieux qui peuvent apparatre  la connexion
du client,  vous d'crire la proc de gestion d'erreur ClientSocket1Error.

Pour finir, j'ai appris tout cela " ttons", donc, les pros y trouveront nombre de choses
qui leurs dplairont. Par exemple, il faudra dj commencer par clore proprement les sockets
 la fermeture du prog (au cas, o il n'y ai pas eu dconnexion "propre" par le bouton ad-hoc.

Donc, il reste encore du travail. Vous croyiez quoi ?   ;-)

}
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
unit Unit1;
interface
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ComCtrls, StdCtrls, WinSock, Buttons, ScktComp, ExtCtrls, Menus, ShellAPI;
type
  TForm1 = class(TForm)
    ClientSocket1: TClientSocket;
    ServerSocket1: TServerSocket;
    PanelConnexion: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    RadioServeur: TRadioButton;
    RadioClient: TRadioButton;
    EditNomServeur: TEdit;
    StatusBar1: TStatusBar;
    PanelJeux: TPanel;
    MemoChat: TMemo;
    ButtonChat: TButton;
    EditChat: TEdit;
    LabelAdresseIP: TLabel;
    ButtonConnexion: TButton;
    ButtonDeconnexion: TButton;
    Img11: TImage;
    Img12: TImage;
    Img13: TImage;
    Img23: TImage;
    Img22: TImage;
    Img21: TImage;
    Img31: TImage;
    Img32: TImage;
    Img33: TImage;
    Img41: TImage;
    Img42: TImage;
    Img43: TImage;
    Img44: TImage;
    Img34: TImage;
    Img24: TImage;
    Img14: TImage;
    ImgDamier: TImage;
    EditNumeroPort: TEdit;
    procedure ServerSocket1ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ServerSocket1ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ButtonConnexionClick(Sender: TObject);
    procedure RadioServeurClick(Sender: TObject);
    procedure RadioClientClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonDeconnexionClick(Sender: TObject);
    procedure ButtonChatClick(Sender: TObject);
    Procedure TraiterTrameRecue(ReceiveText:String);
    Procedure AffichageConnecte;
    Procedure AffichageNonConnecte;
    procedure ImgXY(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    Procedure DeplacerPiece(PieceCliquee:String);
    end;
const
    DebutDeTrame =''; //Indicateur de dbut de trame
    FinDeTrame   ='Ҝ'; //Indicateur de fin de trame
    CodeTrameJeu =''; //Indicateur de trame de jeu
    LgCodeTrame=4;        //Longueur des codes de trame
    LgTrameMax =10000;    //Longueur maxi d'une trame (bidouillage  amliorer...)
var Form1: TForm1;
    Serveur:Boolean=True; //True si l'appli est serveur, False si elle est cliente
    PieceSelectionnee:String=''; //Name de la piece qui a t clique pour tre dplace
implementation
{$R *.dfm}
{*******************************************************************************************}
{*******************************************************************************************}
{***** Recherche du nom de la machine et de son adresse IP *********************************}
{*******************************************************************************************}
{*******************************************************************************************}
function NomMachine:string;
var
Buffer : array[0..255] of char;
BufferSize : DWORD;
begin
  BufferSize := sizeOf(Buffer);
  GetComputerName(@buffer, BufferSize);
  Result:=Buffer;
end;
{*******************************************************************************************}
function AdresseIP(ordinateur : string) : string;
var
WSAData : TWSAData;
Name,Address : String;
Phe : PHostEnt;
begin
  WSAStartup(2,WSAData);
  SetLength(Name,255);
  Phe := GetHostByName(PChar(ordinateur));
  with Phe^ do
  Address := Format ('%d.%d.%d.%d' , [Byte(h_addr^[0]),Byte(h_addr^[1]),
                                      Byte(h_addr^[2]),Byte(h_addr^[3])]);
  WSACleanup;
  AdresseIP:=Address;
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Traitement d'une trame reue ********************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
Procedure TForm1.TraiterTrameRecue(ReceiveText:String);
Var Trame:String;
    TrameLg:Integer;
    CodeTrame:String;
begin
{
Format d'une trame : DebutDeTrame + CodeTrameJeu + Nom de l'image clique + FinDeTrame
                ou : DebutDeTrame + Texte de chat                         + FinDeTrame
}
While (Length(ReceiveText)>0) Do
    Begin
    {-----Recherche d'un dbut de trame-----}
    While (Copy(ReceiveText,1,LgCodeTrame)<>DebutDeTrame) And (Length(ReceiveText)>0) Do
       ReceiveText:=Copy(ReceiveText,2,LgTrameMax);
    If Length(ReceiveText)=0 Then Exit;
    {-----Recherche d'une fin de trame-----}
    If Pos(FinDeTrame,ReceiveText)=0 Then Exit;
    {-----Traitement de la trame-----}
    TrameLg:=Pos(FinDeTrame,ReceiveText)+LgCodeTrame-1;
    Trame:=Copy(ReceiveText,1,TrameLg);
    CodeTrame:=Copy(Trame,LgCodeTrame+1,LgCodeTrame);
    If CodeTrame=CodeTrameJeu Then
       Begin
       MemoChat.Lines.Add('Trame de jeu : '+Trame);
       DeplacerPiece( Copy(Trame,LgCodeTrame*2+1,TrameLg-LgCodeTrame*3) );
       End
    Else
       Begin
       MemoChat.Lines.Add('Trame de chat > ' + Copy(Trame,LgCodeTrame+1,TrameLg-LgCodeTrame*2) );
       End;
    ReceiveText:=Copy(ReceiveText,TrameLg+1,LgTrameMax);
    End;
End;
{*******************************************************************************************}
{*******************************************************************************************}
{*** Socket serveur ************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.ServerSocket1ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
AffichageConnecte;
end;
{*******************************************************************************************}
procedure TForm1.ServerSocket1ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
AffichageNonConnecte;
end;
{*******************************************************************************************}
procedure TForm1.ServerSocket1ClientRead(Sender: TObject; Socket: TCustomWinSocket);
begin
TraiterTrameRecue(Socket.ReceiveText);
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Socket client ***********************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.ClientSocket1Connect(Sender: TObject; Socket: TCustomWinSocket);
begin
AffichageConnecte;
end;
{*******************************************************************************************}
procedure TForm1.ClientSocket1Disconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
AffichageNonConnecte;
end;
{*******************************************************************************************}
procedure TForm1.ClientSocket1Error(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
AffichageNonConnecte;
end;
{*******************************************************************************************}
procedure TForm1.ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
begin
TraiterTrameRecue(Socket.ReceiveText);
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Mise a jour de l'affichage ran selon si on est connect ou non ********************}
{*******************************************************************************************}
{*******************************************************************************************}
Procedure TForm1.AffichageConnecte;
Begin
StatusBar1.SimpleText:='Connect';
PanelConnexion.Visible:=False;
PanelJeux.Visible:=True;
ButtonConnexion.Enabled:=False;
ButtonDeconnexion.Enabled:=True;
End;
{*******************************************************************************************}
Procedure TForm1.AffichageNonConnecte;
Begin
StatusBar1.SimpleText:='Non connect';
PanelConnexion.Visible:=True;
PanelJeux.Visible:=False;
ButtonConnexion.Enabled:=True;
ButtonDeconnexion.Enabled:=False;
End;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Boutons de connexion et de dconnexion **********************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.ButtonConnexionClick(Sender: TObject);
begin
{-----Connexion-----}
If Serveur Then
   Begin
   ServerSocket1.Port:=StrToInt(EditNumeroPort.Text);
   ServerSocket1.Open;
   StatusBar1.SimpleText:='En attente de connexion...';
   End
Else
   Begin
   ClientSocket1.Port:=StrToInt(EditNumeroPort.Text);
   ClientSocket1.Host:=EditNomServeur.Text;
   ClientSocket1.Open;
   StatusBar1.SimpleText:='Connexion en cours...';
   End;

ButtonConnexion.Enabled:=False;
ButtonDeconnexion.Enabled:=True;
end;
{*******************************************************************************************}
procedure TForm1.ButtonDeconnexionClick(Sender: TObject);
begin
{-----Dconnexion-----}
If Serveur Then
   ServerSocket1.Close
Else
   ClientSocket1.Close;

AffichageNonConnecte;
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Radios de choix du mode client ou serveur *******************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.RadioServeurClick(Sender: TObject);
begin
Serveur:=True;
EditNomServeur.Text:=NomMachine;
EditNomServeur.Enabled:=False;
end;
{*******************************************************************************************}
procedure TForm1.RadioClientClick(Sender: TObject);
begin
Serveur:=False;
EditNomServeur.Text:=NomMachine;
EditNomServeur.Enabled:=True;
end;
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.FormCreate(Sender: TObject);
begin
LabelAdresseIP.Caption:='Adresse IP : ' + AdresseIP(NomMachine);
RadioServeurClick(Sender);
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Chat ********************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.ButtonChatClick(Sender: TObject);
begin
{-----Envoi du texte de chat  l'autre joueur-----}
If Serveur Then
   ServerSocket1.Socket.Connections[0].SendText(DebutDeTrame+EditChat.Text+FinDeTrame)
Else
   ClientSocket1.Socket.SendText(DebutDeTrame+EditChat.Text+FinDeTrame);
{-----Affichage du texte envoy-----}
MemoChat.Lines.Add('Trame de chat < '+EditChat.Text);
EditChat.Text:='';
end;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Le dbut d'un jeu que vous pourriez crire... ***************************************}
{*******************************************************************************************}
{*******************************************************************************************}
procedure TForm1.ImgXY(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
{-----Dplacement de la pice-----}
DeplacerPiece( (Sender as TImage).Name );

{-----Envoi du dplacement  l'autre joueur-----}
If Serveur Then
   ServerSocket1.Socket.Connections[0].SendText(DebutDeTrame+CodeTrameJeu+(Sender as TImage).Name+FinDeTrame)
Else
   ClientSocket1.Socket.SendText(DebutDeTrame+CodeTrameJeu+(Sender as TImage).Name+FinDeTrame);
end;
{*******************************************************************************************}
Procedure TForm1.DeplacerPiece(PieceCliquee:String);
Begin
{-----Contrles prliminaires------}
If (PieceCliquee=PieceSelectionnee) Then
   Exit;
If (PieceSelectionnee='') And (TImage(FindComponent(PieceCliquee)).Picture.Bitmap.Width=0) Then
   Exit;

{-----Dplacement de la pice-----}
If PieceSelectionnee='' Then
   Begin
   PieceSelectionnee:=PieceCliquee;
   Screen.Cursor:=crHandPoint;
   End
Else
   Begin
   TImage(FindComponent(PieceCliquee)).Picture.Bitmap:=TImage(FindComponent(PieceSelectionnee)).Picture.Bitmap;
   TImage(FindComponent(PieceSelectionnee)).Picture.Bitmap:=Nil;
   PieceSelectionnee:='';
   Screen.Cursor:=crDefault;
   End;
End;
{*******************************************************************************************}
{*******************************************************************************************}
{***** Fin *********************************************************************************}
{*******************************************************************************************}
{*******************************************************************************************}
END.








